//+------------------------------------------------------------------+
//|                                                  WyattsPivots.mq5|
//+------------------------------------------------------------------+

#property indicator_chart_window
//#property indicator_buffers   0
#property indicator_plots     0

enum     ENUM_TIMEFRAMES2
         {
           _day   = PERIOD_D1, // 1 Day
           _week  = PERIOD_W1, // 1 Week
           _month = PERIOD_MN1 // 1 Month
         };

sinput int              CountPeriods=1;
sinput ENUM_TIMEFRAMES2 TimePeriod2=_week;
sinput bool             PlotPivots=true;
       bool             PlotFuturePivots=false;
sinput bool             PlotPivotLabels=true;
sinput bool             PlotPivotPrices=false;
sinput ENUM_LINE_STYLE  StylePivots=STYLE_SOLID;
sinput int              WidthPivots=1;
sinput color            ColorRes=clrMaroon;
sinput color            ColorPP=clrLightGray;
sinput color            ColorSup=clrGreen;
       bool             PlotMiddle=false;
       ENUM_LINE_STYLE  StyleMidpoints=STYLE_DASH;
       int              WidthMidpoints=1;
       color            ColorM35=clrRed;
       color            ColorM02=clrGreen;
sinput bool             PlotZones=true;
sinput color            ColorBuyZone=clrLightSeaGreen;
sinput color            ColorSellZone=clrLightSalmon;
       bool             PlotBorders=false;
       ENUM_LINE_STYLE  StyleBorder=STYLE_SOLID;
       int              WidthBorder=3;
       color            ColorBorder=0x222222;
       bool             PlotFibots=false;
       bool             PlotFibotLabels=false;
       bool             PlotFibotPrices=false;
       ENUM_LINE_STYLE  StyleFibots1=STYLE_DOT;
       ENUM_LINE_STYLE  StyleFibots2=STYLE_SOLID;
       int              WidthFibots1=1;
       int              WidthFibots2=1;
       color            ColorFibots=0x555555;
       bool             PlotYesterdayOHLC=false;
       bool             PlotOHLCPrices=false;
       ENUM_LINE_STYLE  StyleOHLC=STYLE_DOT;
       int              WidthOHLC=1;
       color            ColorO=clrGold;
       color            ColorH=clrRed;
       color            ColorL=clrGreen;
       color            ColorC=clrMagenta;

ENUM_TIMEFRAMES  TimePeriod = ENUM_TIMEFRAMES(TimePeriod2);

string   period;

datetime timestart,
         timeend;

double   open,
         close,
         high,
         low;

double   PP,         // Pivot Levels
         R1,
         R2,
         R3,
         R4,
         R5,
         R6,        
         R7,        
         S1,
         S2,
         S3,
         S4,
         S5,
         S6,         
         S7,         
         M0,
         M1,
         M2,
         M3,
         M4,
         M5,   
         f214,       // Fibot Levels
         f236,
         f382,
         f50,
         f618,
         f764,
         f786,
         rangeopen1, // OHLC Levels
         rangeopen2,
         rangeclose1,
         rangeclose2;

int      shift;
     
void LevelsDelete(string name)
{
   ObjectDelete(0,"R7"+name);
   ObjectDelete(0,"R6"+name);
   ObjectDelete(0,"R5"+name);
   ObjectDelete(0,"R4"+name);
   ObjectDelete(0,"R3"+name);
   ObjectDelete(0,"R2"+name);
   ObjectDelete(0,"R1"+name);
   ObjectDelete(0,"PP"+name);
   ObjectDelete(0,"S1"+name);
   ObjectDelete(0,"S2"+name);
   ObjectDelete(0,"S3"+name);
   ObjectDelete(0,"S4"+name);
   ObjectDelete(0,"S5"+name);
   ObjectDelete(0,"S6"+name);
   ObjectDelete(0,"S7"+name);
   
   ObjectDelete(0,"R7P"+name);     
   ObjectDelete(0,"R6P"+name);     
   ObjectDelete(0,"R5P"+name);     
   ObjectDelete(0,"R4P"+name);  
   ObjectDelete(0,"R3P"+name);     
   ObjectDelete(0,"R2P"+name);     
   ObjectDelete(0,"R1P"+name);     
   ObjectDelete(0,"PPP"+name);     
   ObjectDelete(0,"S1P"+name);     
   ObjectDelete(0,"S2P"+name);     
   ObjectDelete(0,"S3P"+name);     
   ObjectDelete(0,"S4P"+name);     
   ObjectDelete(0,"S5P"+name);     
   ObjectDelete(0,"S6P"+name);  
   ObjectDelete(0,"S7P"+name);  

   ObjectDelete(0,"R7L"+name);     
   ObjectDelete(0,"R6L"+name);     
   ObjectDelete(0,"R5L"+name);     
   ObjectDelete(0,"R4L"+name);                
   ObjectDelete(0,"R3L"+name);     
   ObjectDelete(0,"R2L"+name);     
   ObjectDelete(0,"R1L"+name);     
   ObjectDelete(0,"PPL"+name);     
   ObjectDelete(0,"S1L"+name);     
   ObjectDelete(0,"S2L"+name);     
   ObjectDelete(0,"S3L"+name);     
   ObjectDelete(0,"S4L"+name);     
   ObjectDelete(0,"S5L"+name);     
   ObjectDelete(0,"S6L"+name); 
   ObjectDelete(0,"S7L"+name); 
   
   ObjectDelete(0,"M0"+name);
   ObjectDelete(0,"M1"+name);
   ObjectDelete(0,"M2"+name);
   ObjectDelete(0,"M3"+name);
   ObjectDelete(0,"M4"+name);
   ObjectDelete(0,"M5"+name);
                 
   ObjectDelete(0,"M0P"+name);     
   ObjectDelete(0,"M1P"+name);     
   ObjectDelete(0,"M2P"+name);     
   ObjectDelete(0,"M3P"+name);     
   ObjectDelete(0,"M4P"+name);     
   ObjectDelete(0,"M5P"+name);     

   ObjectDelete(0,"M0L"+name);     
   ObjectDelete(0,"M1L"+name);     
   ObjectDelete(0,"M2L"+name);     
   ObjectDelete(0,"M3L"+name);     
   ObjectDelete(0,"M4L"+name);     
   ObjectDelete(0,"M5L"+name);     

   ObjectDelete(0,"BZ"+name);     
   ObjectDelete(0,"SZ"+name);     
   
   ObjectDelete(0,"BDU"+name);     
   ObjectDelete(0,"BDD"+name);     
   ObjectDelete(0,"BDL"+name);     
   ObjectDelete(0,"BDR"+name);     
     
   ObjectDelete(0,"f214a"+name);
   ObjectDelete(0,"f236a"+name);
   ObjectDelete(0,"f382a"+name);
   ObjectDelete(0,"f50a"+name);
   ObjectDelete(0,"f618a"+name);
   ObjectDelete(0,"f764a"+name);
   ObjectDelete(0,"f786a"+name);
      
   ObjectDelete(0,"f214b"+name);
   ObjectDelete(0,"f236b"+name);
   ObjectDelete(0,"f382b"+name);
   ObjectDelete(0,"f50b"+name);
   ObjectDelete(0,"f618b"+name);
   ObjectDelete(0,"f764b"+name);
   ObjectDelete(0,"f786b"+name);
      
   ObjectDelete(0,"f214p"+name);
   ObjectDelete(0,"f236p"+name);
   ObjectDelete(0,"f382p"+name);
   ObjectDelete(0,"f50p"+name);
   ObjectDelete(0,"f618p"+name);
   ObjectDelete(0,"f764p"+name);
   ObjectDelete(0,"f786p"+name);
      
   ObjectDelete(0,"f214l"+name);
   ObjectDelete(0,"f236l"+name);
   ObjectDelete(0,"f382l"+name);
   ObjectDelete(0,"f50l"+name);
   ObjectDelete(0,"f618l"+name);
   ObjectDelete(0,"f764l"+name);
   ObjectDelete(0,"f786l"+name);
      
   ObjectDelete(0,"open"+name);
   ObjectDelete(0,"high"+name);
   ObjectDelete(0,"low"+name);
   ObjectDelete(0,"close"+name);

   ObjectDelete(0,"openp"+name);
   ObjectDelete(0,"highp"+name);
   ObjectDelete(0,"lowp"+name);
   ObjectDelete(0,"closep"+name);
}

bool PlotTrend(const long              chart_ID=0,
               string                  name="trendline",
               const int               subwindow=0,
               datetime                time1=0,
               double                  price1=0,
               datetime                time2=0,
               double                  price2=0,             
               const color             clr=clrBlack,
               const ENUM_LINE_STYLE   style=STYLE_SOLID,
               const int               width=2,
               const bool              back=true,
               const bool              selection=false,
               const bool              ray=false,
               const bool              hidden=true)
{
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_TREND,subwindow,time1,price1,time2,price2))
   {
      Print(__FUNCTION__,": failed to create arrow = ",GetLastError());
      return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_RAY,ray);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   return(true);
}

bool PlotRectangle(  const long        chart_ID=0,
                     string            name="rectangle", 
                     const int         subwindow=0,
                     datetime          time1=0,
                     double            price1=1,
                     datetime          time2=0, 
                     double            price2=0, 
                     const color       clr=clrGray,
                     const bool        back=true,
                     const bool        selection=false,
                     const bool        hidden=true)
{
   if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE,subwindow,time1,price1,time2,price2))
   {
      Print(__FUNCTION__,": failed to create arrow = ",GetLastError());
      return(false);
   }
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSetInteger(chart_ID,name,OBJPROP_FILL,true); 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   return(true);
}

bool PlotText(       const long        chart_ID=0,
                     string            name="text", 
                     const int         subwindow=0,
                     datetime          time1=0, 
                     double            price1=0, 
                     const string      text="text",
                     const string      font="Arial",
                     const int         font_size=10,
                     const color       clr=clrGray,
                     const ENUM_ANCHOR_POINT anchor = ANCHOR_RIGHT_UPPER,
                     const bool        back=true,
                     const bool        selection=false,
                     const bool        hidden=true)
{
   ResetLastError();
   if(!ObjectCreate(chart_ID,name,OBJ_TEXT,subwindow,time1,price1))
   {
      Print(__FUNCTION__,": failed to create arrow = ",GetLastError());
      return(false);
   }
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
   return(true);
} 
       
void LevelsDraw(  int      shft,
                  datetime tmestrt, 
                  datetime tmend, 
                  string   name,
                  bool     future)
{
   high  = iHigh(NULL,TimePeriod,shft);
   low   = iLow(NULL,TimePeriod,shft);
   open  = iOpen(NULL,TimePeriod,shft);
   if(future==false){close = iClose(NULL,TimePeriod,shft);}else{close = SymbolInfoDouble(Symbol(),SYMBOL_BID);}      
   
   if(!(high-low)) return;
   PP  = (high+low+close)/3.0;
           
   R1 = PP+(high - low)*0.382;
   R2 = PP+(high - low)*0.618;
   R3 = PP+(high - low)*0.786;
   R4 = PP+(high - low)*1.00;
   R5 = PP+(high - low)*1.382;
   R6 = PP+(high - low)*1.618;
   R7 = PP+(high - low)*2.00;
               
   S1 = PP-(high - low)*0.382;
   S2 = PP-(high - low)*0.618;
   S3 = PP-(high - low)*0.786;
   S4 = PP-(high - low)*1.00;
   S5 = PP-(high - low)*1.382;
   S6 = PP-(high - low)*1.618;
   S7 = PP-(high - low)*2.00;
                
   M0=0.5*(S2+S3);
   M1=0.5*(S1+S2);
   M2=0.5*(PP+S1);
   M3=0.5*(PP+R1);
   M4=0.5*(R1+R2);
   M5=0.5*(R2+R3);
      
   f214 = (low+(((high-low)/100)*(100-21.4)));
   f236 = (low+(((high-low)/100)*(100-23.6)));
   f382 = (low+(((high-low)/100)*(100-38.2)));
   f50  = (low+(((high-low)/100)*(100-50)));
   f618 = (low+(((high-low)/100)*(38.2)));
   f764 = (low+(((high-low)/100)*(23.6)));
   f786 = (low+(((high-low)/100)*(21.4)));
      
   rangeopen1  = (open-low)/((high-low)/100);
   rangeopen2  = 100-((open-low)/((high-low)/100));
   rangeclose1 = (close-low)/((high-low)/100);
   rangeclose2 = 100-((close-low)/((high-low)/100));   
   
   
   if(PlotZones){
      PlotRectangle(0,"BZ"+name,0,tmestrt,S3,tmend,S4,ColorBuyZone);    
      PlotRectangle(0,"SZ"+name,0,tmestrt,R3,tmend,R4,ColorSellZone);}

   if(PlotPivots){                                 
      PlotTrend(0,"R7"+name,0,tmestrt,R7,tmend,R7,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"R6"+name,0,tmestrt,R6,tmend,R6,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"R5"+name,0,tmestrt,R5,tmend,R5,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"R4"+name,0,tmestrt,R4,tmend,R4,ColorRes,StylePivots,WidthPivots);  
      PlotTrend(0,"R3"+name,0,tmestrt,R3,tmend,R3,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"R2"+name,0,tmestrt,R2,tmend,R2,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"R1"+name,0,tmestrt,R1,tmend,R1,ColorRes,StylePivots,WidthPivots);     
      PlotTrend(0,"PP"+name,0,tmestrt,PP,tmend,PP,ColorPP,StylePivots,WidthPivots);     
      PlotTrend(0,"S1"+name,0,tmestrt,S1,tmend,S1,ColorSup,StylePivots,WidthPivots);     
      PlotTrend(0,"S2"+name,0,tmestrt,S2,tmend,S2,ColorSup,StylePivots,WidthPivots);     
      PlotTrend(0,"S3"+name,0,tmestrt,S3,tmend,S3,ColorSup,StylePivots,WidthPivots);
      PlotTrend(0,"S4"+name,0,tmestrt,S4,tmend,S4,ColorSup,StylePivots,WidthPivots);     
      PlotTrend(0,"S5"+name,0,tmestrt,S5,tmend,S5,ColorSup,StylePivots,WidthPivots);     
      PlotTrend(0,"S6"+name,0,tmestrt,S6,tmend,S6,ColorSup,StylePivots,WidthPivots);
      PlotTrend(0,"S7"+name,0,tmestrt,S7,tmend,S7,ColorSup,StylePivots,WidthPivots);
      if(PlotPivotLabels){
         PlotText(0,"R7L"+name,0,tmestrt,R7,"R200","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"R6L"+name,0,tmestrt,R6,"R161","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"R5L"+name,0,tmestrt,R5,"R138","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"R4L"+name,0,tmestrt,R4,"R100","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);      
         PlotText(0,"R3L"+name,0,tmestrt,R3,"R78","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"R2L"+name,0,tmestrt,R2,"R61","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"R1L"+name,0,tmestrt,R1,"R38","Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"PPL"+name,0,tmestrt,PP,"PP","Arial",8,ColorPP,ANCHOR_LEFT_UPPER);
         PlotText(0,"S1L"+name,0,tmestrt,S1,"S38","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"S2L"+name,0,tmestrt,S2,"S61","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"S3L"+name,0,tmestrt,S3,"S78","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);            
         PlotText(0,"S4L"+name,0,tmestrt,S4,"S100","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"S5L"+name,0,tmestrt,S5,"S138","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"S6L"+name,0,tmestrt,S6,"S161","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"S7L"+name,0,tmestrt,S7,"S200","Arial",8,ColorSup,ANCHOR_LEFT_UPPER);}
      if(PlotPivotPrices){
         PlotText(0,"R7P"+name,0,tmend,R7,DoubleToString(R7,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R6P"+name,0,tmend,R6,DoubleToString(R6,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R5P"+name,0,tmend,R5,DoubleToString(R5,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R4P"+name,0,tmend,R4,DoubleToString(R4,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R3P"+name,0,tmend,R3,DoubleToString(R3,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R2P"+name,0,tmend,R2,DoubleToString(R2,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"R1P"+name,0,tmend,R1,DoubleToString(R1,4),"Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"PPP"+name,0,tmend,PP,DoubleToString(PP,4),"Arial",8,ColorPP,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S1P"+name,0,tmend,S1,DoubleToString(S1,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S2P"+name,0,tmend,S2,DoubleToString(S2,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S3P"+name,0,tmend,S3,DoubleToString(S3,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S4P"+name,0,tmend,S4,DoubleToString(S4,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S5P"+name,0,tmend,S5,DoubleToString(S5,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S6P"+name,0,tmend,S6,DoubleToString(S6,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"S7P"+name,0,tmend,S7,DoubleToString(S7,4),"Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);}}

   if(PlotMiddle){
      PlotTrend(0,"M0"+name,0,tmestrt,M0,tmend,M0,ColorM02,StyleMidpoints,WidthMidpoints);     
      PlotTrend(0,"M1"+name,0,tmestrt,M1,tmend,M1,ColorM02,StyleMidpoints,WidthMidpoints);     
      PlotTrend(0,"M2"+name,0,tmestrt,M2,tmend,M2,ColorM02,StyleMidpoints,WidthMidpoints);     
      PlotTrend(0,"M3"+name,0,tmestrt,M3,tmend,M3,ColorM35,StyleMidpoints,WidthMidpoints);     
      PlotTrend(0,"M4"+name,0,tmestrt,M4,tmend,M4,ColorM35,StyleMidpoints,WidthMidpoints);     
      PlotTrend(0,"M5"+name,0,tmestrt,M5,tmend,M5,ColorM35,StyleMidpoints,WidthMidpoints);
      if(PlotPivotLabels){
         PlotText(0,"M0L"+name,0,tmend,M0,"M0","Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"M1L"+name,0,tmend,M1,"M1","Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"M2L"+name,0,tmend,M2,"M2","Arial",8,ColorSup,ANCHOR_RIGHT_UPPER);
         PlotText(0,"M3L"+name,0,tmend,M3,"M3","Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"M4L"+name,0,tmend,M4,"M4","Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);
         PlotText(0,"M5L"+name,0,tmend,M5,"M5","Arial",8,ColorRes,ANCHOR_RIGHT_UPPER);}
      if(PlotPivotPrices){
         PlotText(0,"M0P"+name,0,tmestrt,M0,DoubleToString(M0,4),"Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"M1P"+name,0,tmestrt,M1,DoubleToString(M1,4),"Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"M2P"+name,0,tmestrt,M2,DoubleToString(M2,4),"Arial",8,ColorSup,ANCHOR_LEFT_UPPER);
         PlotText(0,"M3P"+name,0,tmestrt,M3,DoubleToString(M3,4),"Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"M4P"+name,0,tmestrt,M4,DoubleToString(M4,4),"Arial",8,ColorRes,ANCHOR_LEFT_UPPER);
         PlotText(0,"M5P"+name,0,tmestrt,M5,DoubleToString(M5,4),"Arial",8,ColorRes,ANCHOR_LEFT_UPPER);}}   

   if(PlotFibots){
      PlotTrend(0,"f236a"+name,0,tmestrt,f236,tmend,f236,ColorFibots,StyleFibots1,WidthFibots1);
      PlotTrend(0,"f382a"+name,0,tmestrt,f382,tmend,f382,ColorFibots,StyleFibots1,WidthFibots1);
      PlotTrend(0,"f50a"+name,0,tmestrt,f50,tmend,f50,ColorFibots,StyleFibots1,WidthFibots1);
      PlotTrend(0,"f618a"+name,0,tmestrt,f618,tmend,f618,ColorFibots,StyleFibots1,WidthFibots1);
      PlotTrend(0,"f786a"+name,0,tmestrt,f786,tmend,f786,ColorFibots,StyleFibots1,WidthFibots1);
      PlotTrend(0,"f236b"+name,0,tmestrt+TimePeriod*10,f236,tmend,f236,ColorFibots,StyleFibots2,WidthFibots2);
      PlotTrend(0,"f382b"+name,0,tmestrt+TimePeriod*10,f382,tmend,f382,ColorFibots,StyleFibots2,WidthFibots2);
      PlotTrend(0,"f50b"+name,0,tmestrt+TimePeriod*10,f50,tmend,f50,ColorFibots,StyleFibots2,WidthFibots2);
      PlotTrend(0,"f618b"+name,0,tmestrt+TimePeriod*10,f618,tmend,f618,ColorFibots,StyleFibots2,WidthFibots2);
      PlotTrend(0,"f786b"+name,0,tmestrt+TimePeriod*10,f786,tmend,f786,ColorFibots,StyleFibots2,WidthFibots2);
      if(PlotFibotLabels){
         PlotText(0,"f236l"+name,0,tmend,f236,"23.6%","Arial",8,ColorFibots,ANCHOR_RIGHT_UPPER);         
         PlotText(0,"f382l"+name,0,tmend,f382,"38.2%","Arial",8,ColorFibots,ANCHOR_RIGHT_UPPER);         
         PlotText(0,"f50l"+name,0,tmend,f50,"50%","Arial",8,ColorFibots,ANCHOR_RIGHT_UPPER);         
         PlotText(0,"f618l"+name,0,tmend,f618,"61.8%","Arial",8,ColorFibots,ANCHOR_RIGHT_UPPER);         
         PlotText(0,"f786l"+name,0,tmend,f786,"78.6%","Arial",8,ColorFibots,ANCHOR_RIGHT_UPPER);}
      if(PlotFibotPrices){
         PlotText(0,"f236p"+name,0,tmestrt,f236,DoubleToString(f236,4),"Arial",8,ColorFibots,ANCHOR_LEFT_UPPER);         
         PlotText(0,"f382p"+name,0,tmestrt,f382,DoubleToString(f382,4),"Arial",8,ColorFibots,ANCHOR_LEFT_UPPER);         
         PlotText(0,"f50p"+name,0,tmestrt,f50,DoubleToString(f50,4),"Arial",8,ColorFibots,ANCHOR_LEFT_UPPER);         
         PlotText(0,"f618p"+name,0,tmestrt,f618,DoubleToString(f618,4),"Arial",8,ColorFibots,ANCHOR_LEFT_UPPER);         
         PlotText(0,"f786p"+name,0,tmestrt,f786,DoubleToString(f786,4),"Arial",8,ColorFibots,ANCHOR_LEFT_UPPER);}}
         
   if(PlotYesterdayOHLC){
      PlotTrend(0,"open"+name,0,tmestrt,open,tmestrt+TimePeriod*13,open,ColorO,StyleOHLC,WidthOHLC);
      PlotTrend(0,"high"+name,0,tmestrt,high,tmestrt+TimePeriod*20,high,ColorH,StyleOHLC,WidthOHLC);
      PlotTrend(0,"low"+name,0,tmestrt,low,tmestrt+TimePeriod*20,low,ColorL,StyleOHLC,WidthOHLC);
      PlotTrend(0,"close"+name,0,tmestrt,close,tmestrt+TimePeriod*13,close,ColorC,StyleOHLC,WidthOHLC);         
      if(PlotOHLCPrices){
         PlotText(0,"openp"+name,0,tmestrt+TimePeriod*10,open,DoubleToString(rangeopen1,1)+"/"+DoubleToString(rangeopen2,1)+"%","Arial",8,ColorO,6);
         PlotText(0,"closep"+name,0,tmestrt+TimePeriod*10,close,DoubleToString(rangeclose1,1)+"/"+DoubleToString(rangeclose2,1)+"%","Arial",8,ColorC,6);}}   

   if(PlotBorders){
   if((future==false)&&(shift != 0)){
//    PlotTrend(0,"BDU"+name,0,tmestrt,R3,tmend,R3,ColorBorder,StyleBorder,WidthBorder);      // top
//    PlotTrend(0,"BDD"+name,0,tmestrt,S3,tmend,S3,ColorBorder,StyleBorder,WidthBorder);      // bottom
      PlotTrend(0,"BDL"+name,0,tmestrt,R3,tmestrt,S3,ColorBorder,StyleBorder,WidthBorder);    // left
      PlotTrend(0,"BDR"+name,0,tmend,R3,tmend,S3,ColorBorder,StyleBorder,WidthBorder);}}      // right

}

int OnInit()
{
   if(TimePeriod==PERIOD_M1||TimePeriod==PERIOD_CURRENT){TimePeriod=PERIOD_M5;period="M5";}
   if(TimePeriod==PERIOD_M5){period="M5";}
   if(TimePeriod==PERIOD_M15){period="M15";}
   if(TimePeriod==PERIOD_M30){period="M30";}
   if(TimePeriod==PERIOD_H1){period="H1";}
   if(TimePeriod==PERIOD_H4){period="H4";}
   if(TimePeriod==PERIOD_D1){period="D1";}
   if(TimePeriod==PERIOD_W1){period="W1";}
   if(TimePeriod==PERIOD_MN1){period="MN1";}  
   return(0);
}   
   
void OnDeinit( const int reason )
{
   for(shift=0;shift<=CountPeriods;shift++)
   {
      LevelsDelete(period+(string)shift);
   }
   LevelsDelete("F"+period);
   Comment("");
}

int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& _open[],
                const double& _high[],
                const double& _low[],
                const double& _close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   if (Bars(_Symbol,_Period)<rates_total) return(-1);

//   for (int i=(int)MathMax(prev_calculated-1,0); i<rates_total && !IsStopped(); i++)
   for(shift=0;shift<=CountPeriods;shift++)
   {
      LevelsDelete(period+(string)shift);
   }
   LevelsDelete("F"+period);
   
   for(shift=CountPeriods-1;shift>=0;shift--)
   {
      timestart = iTime(NULL,TimePeriod,shift);
      timeend   = iTime(NULL,TimePeriod,shift)+TF(TimePeriod)*60;   
         
      LevelsDraw(shift+1,timestart,timeend,period+(string)shift,false);                
   }
   
   if(PlotFuturePivots)
   {
      timestart=iTime(NULL,TimePeriod,0)+TF(TimePeriod)*60;
      timeend=iTime(NULL,TimePeriod,0)+TF(TimePeriod)*120;

      LevelsDraw(0,timestart,timeend,"F"+period,true);      
   }
   
   return(0);
}

int TF( ENUM_TIMEFRAMES tf )
{
   switch(tf)
   {
      default            :
      case PERIOD_CURRENT: return(0);
      case PERIOD_M1     : return(1);
      case PERIOD_M5     : return(5);
      case PERIOD_M15    : return(15);
      case PERIOD_M30    : return(30);
      case PERIOD_H1     : return(60);
      case PERIOD_H4     : return(240);
      case PERIOD_D1     : return(1440);
      case PERIOD_W1     : return(10080);
      case PERIOD_MN1    : return(43200);
      case PERIOD_M2     : return(2);
      case PERIOD_M3     : return(3);
      case PERIOD_M4     : return(4);   
      case PERIOD_M6     : return(6);
      case PERIOD_M10    : return(10);
      case PERIOD_M12    : return(12);
      case PERIOD_H2     : return(120);
      case PERIOD_H3     : return(180);
      case PERIOD_H6     : return(360);
      case PERIOD_H8     : return(480);
      case PERIOD_H12    : return(720);
   }
}
